/*
	File:		SerialShim.h

	Contains:	Public definitions for the Serial Shim

	Version:	xxx put version here xxx


				
	Copyright:	 1995-1998 by Apple Computer, Inc., all rights reserved.

*/

#ifndef	_SERIALSHIM_
#define	_SERIALSHIM_

// Shim definitions etc.

typedef UInt32	ShimRefNum;
typedef UInt32	*IconPtr;

#define kInvalidRef		-1

// Shim interface structure

typedef	struct	SerialShimInterface
{
	StringPtr			DRVRInName;
	StringPtr			DRVROutName;
	StringPtr 			CRMName;
	IconPtr 			CRMIcon;
	UInt32				MaxSpeed;
	UInt32				RefCon;
	CFragConnectionID	ConnID;
	
} SerialShimInterface;

// Hardware abstarction codes

enum
{
	SerHAL_Initialize		=	0,
	SerHAL_Terminate		=	1,
	SerHAL_Read				=	2,
	SerHAL_Write			=	3,
	SerHAL_SetConfiguration	=	4,
	SerHAL_SetInputBuffer	=	5,
	SerHAL_SetFlowControl	=	6,
	SerHAL_SetBreak			=	7,
	SerHAL_SetDTERate		=	8,
	SerHAL_SetDTR			=	9,
	SerHAL_SetParity		=	10,
	SerHAL_SetXOffFlag		=	11,
	SerHAL_SendXOn			=	12,
	SerHAL_SendXOff			=	13,
	SerHAL_Miscellaneous	=	14,
	SerHAL_GetBuffer		=	15,
	SerHAL_GetStatus		=	16,
	SerHAL_GetVersion		=	17,
	SerHAL_ControlExtend	=	18,
	SerHAL_StatusExtend		=	19
};

#endif
