#
#	File:		USBSampleStorageDriver.make
#
#	Contains:	A sample USB Storage Class driver
#
#	Version:		1.1
#
#	Copyright:	 1998-1999 by Apple Computer, Inc., all rights reserved.
#
MAKEFILE     = USBSampleStorageDriver.make
MondoBuild = {MAKEFILE}  # Make blank to avoid rebuilds when makefile is modified

#
#	symbol options
#
SymPPC      =  -sym full

#
#	objects directory
#
ObjDirPPC   = :::Objects:

#
#	Targets directory
#
TargetDir	 = :::Targets:

#
# Headers and Libraries directory
#
LibrariesDir = :::Libraries:

#
# Sample Drivers Shared Headers directory
#
SharedHeadersDir = :

#
#	compiler options
#
PPCCOptions  = {SymPPC} -d DEBUG=0 -align mac68k -i {SharedHeadersDir}
		
#
#	PPC objects
#
ObjectsPPC  =																
		"{ObjDirPPC}SampleStorageDriver.c.x"						
		"{ObjDirPPC}SampleStorageDriverAPI.c.x"					
		"{ObjDirPPC}SampleStorageHeader.c.x"


#
#	Build Target
#
StorageDriverTarget	= {TargetDir}USBSampleStorageDriver
		
		
USBSampleStorageDriver  {StorageDriverTarget}


#
#	Build Resource fork of the driver
#
{StorageDriverTarget}		
						"{SharedHeadersDir}SampleStorageVersion.h"	
						"SampleStorageDriver.r"							
						{MondoBuild}
	Rez																		
		-i "{RIncludes}"													
		-i "{SharedHeadersDir}"											
		"{RIncludes}MacTypes.r"												
		"SampleStorageDriver.r"											
		-a																		
		-o {Targ}

#
#	Storage class driver is compiled with PPC compiler
#		and added into the USBSampleStorageDriver file
#
{StorageDriverTarget}  												
				{MondoBuild} 											
				{ObjectsPPC}												
				"SampleStorageDriver.exp"
	PPCLink 																	
	 -SYM big																
	 -map "{ObjDirPPC}USBSampleStorageDriver.map	"			
		-t 'ndrv'															
		-c 'usbd'															
		-o {StorageDriverTarget} {SymPPC}							
		{ObjectsPPC} 														
		-xm sharedlibrary													
		-share context														
		-@export "SampleStorageDriver.exp"							
		"{LibrariesDir}USBServicesLib" 								
		"{SharedLibraries}InterfaceLib" 								
		"{SharedLibraries}NameRegistryLib"							
		"{SharedLibraries}DriverLoaderLib"							
		"{SharedLibraries}DriverServicesLib" 						
		"{SharedLibraries}PCILib"										
		"{SharedLibraries}StdCLib"										
		"{PPCLibraries}PPCCRuntime.o"

#
#	Storage class driver
#
"{ObjDirPPC}SampleStorageDriver.c.x" 			{MondoBuild}									
															"SampleStorageDriver.c" 						
															"{LibrariesDir}USB.h"							
															"SampleStorageDriver.h"
	{PPCC} SampleStorageDriver.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}SampleStorageDriverAPI.c.x" 		{MondoBuild}									
															SampleStorageDriverAPI.c 						
															"{LibrariesDir}USB.h"							
                                   				"{SharedHeadersDir}SampleStorageDriverAPI.h"
	{PPCC} SampleStorageDriverAPI.c -o {Targ} {PPCCOptions}

#
#	Storage class driver USB interfaces
#
"{ObjDirPPC}SampleStorageHeader.c.x" 		{MondoBuild}										
															SampleStorageHeader.c 							
 															"{LibrariesDir}USB.h"							
                                 				"SampleStorageDriver.h"
	{PPCC} SampleStorageHeader.c -o {Targ} {PPCCOptions}

# eof
